/* ICalTime.c generated by valac 0.48.11, the Vala compiler
 * generated from ICalTime.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <libical-glib/libical-glib.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

GTimeZone* calendar_util_icaltime_get_timezone (ICalTime* date);
GDateTime* calendar_util_icaltime_to_datetime (ICalTime* date);

/**
     * Gets the timezone of the given TimeType as a GLib.TimeZone.
     * For floating times, returns the local timezone.
     */
static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = (const gchar*) (((gchar*) self) + offset);
	return result;
}

GTimeZone*
calendar_util_icaltime_get_timezone (ICalTime* date)
{
	gchar* tzid = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp6_;
	ICalTimezone* timezone = NULL;
	gboolean _tmp18_ = FALSE;
	ICalTimezone* _tmp19_;
	ICalTimezone* _tmp22_;
	gint is_daylight = 0;
	gint interval = 0;
	ICalTimezone* _tmp24_;
	gint _tmp25_ = 0;
	gint _tmp26_;
	gboolean is_positive = FALSE;
	gint hours = 0;
	gint minutes = 0;
	const gchar* _tmp27_ = NULL;
	gchar* hour_string = NULL;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	GTimeZone* _tmp30_;
	GTimeZone* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	if (i_cal_time_is_date (date)) {
		GTimeZone* _tmp0_;
		_tmp0_ = g_time_zone_new_local ();
		result = _tmp0_;
		return result;
	}
	_tmp1_ = i_cal_time_get_tzid (date);
	_tmp2_ = g_strdup (_tmp1_);
	tzid = _tmp2_;
	_tmp3_ = tzid;
	if (_tmp3_ == NULL) {
		ICalTimezone* _tmp4_;
		GTimeZone* _tmp5_;
		_tmp4_ = i_cal_time_get_timezone (date);
		_vala_assert (_tmp4_ == NULL, "date.get_timezone () == null");
		_tmp5_ = g_time_zone_new_local ();
		result = _tmp5_;
		_g_free0 (tzid);
		return result;
	}
	_tmp6_ = tzid;
	if (_tmp6_ != NULL) {
		gchar* prefix = NULL;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp7_ = g_strdup ("/freeassociation.sourceforge.net/");
		prefix = _tmp7_;
		_tmp8_ = tzid;
		_tmp9_ = prefix;
		if (g_str_has_prefix (_tmp8_, _tmp9_)) {
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			const gchar* _tmp14_;
			GTimeZone* _tmp15_;
			_tmp10_ = tzid;
			_tmp11_ = prefix;
			_tmp12_ = strlen (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = string_offset (_tmp10_, (glong) _tmp13_);
			_tmp15_ = g_time_zone_new (_tmp14_);
			result = _tmp15_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		} else {
			const gchar* _tmp16_;
			GTimeZone* _tmp17_;
			_tmp16_ = tzid;
			_tmp17_ = g_time_zone_new (_tmp16_);
			result = _tmp17_;
			_g_free0 (prefix);
			_g_free0 (tzid);
			return result;
		}
		_g_free0 (prefix);
	}
	timezone = NULL;
	_tmp19_ = timezone;
	if (_tmp19_ == NULL) {
		ICalTimezone* _tmp20_;
		_tmp20_ = i_cal_time_get_timezone (date);
		_tmp18_ = _tmp20_ != NULL;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		ICalTimezone* _tmp21_;
		_tmp21_ = i_cal_time_get_timezone (date);
		timezone = _tmp21_;
	}
	_tmp22_ = timezone;
	if (_tmp22_ == NULL) {
		GTimeZone* _tmp23_;
		_tmp23_ = g_time_zone_new_local ();
		result = _tmp23_;
		_g_free0 (tzid);
		return result;
	}
	_tmp24_ = timezone;
	_tmp26_ = i_cal_timezone_get_utc_offset (_tmp24_, date, &_tmp25_);
	is_daylight = _tmp25_;
	interval = _tmp26_;
	is_positive = interval >= 0;
	interval = abs (interval);
	hours = interval / 3600;
	minutes = (interval % 3600) / 60;
	if (is_positive) {
		_tmp27_ = "+";
	} else {
		_tmp27_ = "-";
	}
	_tmp28_ = g_strdup_printf ("%s%02d:%02d", _tmp27_, hours, minutes);
	hour_string = _tmp28_;
	_tmp29_ = hour_string;
	_tmp30_ = g_time_zone_new (_tmp29_);
	result = _tmp30_;
	_g_free0 (hour_string);
	_g_free0 (tzid);
	return result;
}

/**
     * Converts the given ICal.Time to a DateTime.
     * XXX : Track next versions of evolution in order to convert ICal.Timezone to GLib.TimeZone with a dedicated function…
     */
GDateTime*
calendar_util_icaltime_to_datetime (ICalTime* date)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	i_cal_time_get_date (date, &_tmp0_, &_tmp1_, &_tmp2_);
	year = _tmp0_;
	month = _tmp1_;
	day = _tmp2_;
	i_cal_time_get_time (date, &_tmp3_, &_tmp4_, &_tmp5_);
	hour = _tmp3_;
	minute = _tmp4_;
	second = _tmp5_;
	_tmp6_ = calendar_util_icaltime_get_timezone (date);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_date_time_new (_tmp7_, year, month, day, hour, minute, (gdouble) second);
	_tmp9_ = _tmp8_;
	_g_time_zone_unref0 (_tmp7_);
	result = _tmp9_;
	return result;
}

