/* Daemon.c generated by valac 0.48.11, the Vala compiler
 * generated from Daemon.vala, do not modify */

/*
 * Copyright 2018 elementary, Inc. (https://elementary.io)
 *           2014 Corentin Noël <corentin@elementary.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <libecal/libecal.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "elementary-calendar.h"
#include <libedataserver/libedataserver.h>
#include <libical-glib/libical-glib.h>
#include <float.h>
#include <math.h>
#include <granite.h>

#define MAYA_TYPE_DAEMON (maya_daemon_get_type ())
#define MAYA_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_TYPE_DAEMON, MayaDaemon))
#define MAYA_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_TYPE_DAEMON, MayaDaemonClass))
#define MAYA_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_TYPE_DAEMON))
#define MAYA_IS_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_TYPE_DAEMON))
#define MAYA_DAEMON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_TYPE_DAEMON, MayaDaemonClass))

typedef struct _MayaDaemon MayaDaemon;
typedef struct _MayaDaemonClass MayaDaemonClass;
typedef struct _MayaDaemonPrivate MayaDaemonPrivate;
enum  {
	MAYA_DAEMON_0_PROPERTY,
	MAYA_DAEMON_NUM_PROPERTIES
};
static GParamSpec* maya_daemon_properties[MAYA_DAEMON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentAlarmTrigger_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarmTrigger_free (var), NULL)))
#define __vala_ECalComponentAlarm_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarm_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _MayaDaemonAddTimeoutData MayaDaemonAddTimeoutData;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MayaDaemon {
	GApplication parent_instance;
	MayaDaemonPrivate * priv;
};

struct _MayaDaemonClass {
	GApplicationClass parent_class;
};

struct _MayaDaemonPrivate {
	GeeHashMap* event_uid;
};

struct _Block1Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block2Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block3Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block4Data {
	int _ref_count_;
	MayaDaemon* self;
	gchar* uid;
	ESource* source;
	ECalComponent* event;
	gpointer _async_data_;
};

struct _MayaDaemonAddTimeoutData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MayaDaemon* self;
	ESource* source;
	ECalComponent* event;
	guint interval;
	Block4Data* _data4_;
	gchar* _tmp0_;
	GeeHashMap* _tmp1_;
};

extern gboolean maya_has_debug;
gboolean maya_has_debug = FALSE;
static gint MayaDaemon_private_offset;
static gpointer maya_daemon_parent_class = NULL;

GType maya_daemon_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaDaemon, g_object_unref)
static void maya_daemon_real_activate (GApplication* base);
static void maya_daemon_load_today_events (MayaDaemon* self);
static void maya_daemon_on_events_added (MayaDaemon* self,
                                  ESource* source,
                                  GeeCollection* events);
static void _maya_daemon_on_events_added_calendar_event_store_events_added (CalendarEventStore* _sender,
                                                                     ESource* source,
                                                                     GeeCollection* events,
                                                                     gpointer self);
static void maya_daemon_on_events_updated (MayaDaemon* self,
                                    ESource* source,
                                    GeeCollection* events);
static void _maya_daemon_on_events_updated_calendar_event_store_events_updated (CalendarEventStore* _sender,
                                                                         ESource* source,
                                                                         GeeCollection* events,
                                                                         gpointer self);
static void maya_daemon_on_events_removed (MayaDaemon* self,
                                    ESource* source,
                                    GeeCollection* events);
static void _maya_daemon_on_events_removed_calendar_event_store_events_removed (CalendarEventStore* _sender,
                                                                         ESource* source,
                                                                         GeeCollection* events,
                                                                         gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_);
static void maya_daemon_add_event (MayaDaemon* self,
                            ESource* source,
                            ECalComponent* event);
static gboolean ___lambda4__gsource_func (gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block2Data* _data2_);
static void maya_daemon_update_event (MayaDaemon* self,
                               ESource* source,
                               ECalComponent* event);
static gboolean ___lambda6__gsource_func (gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block3Data* _data3_);
static void maya_daemon_remove_event (MayaDaemon* self,
                               ESource* source,
                               ECalComponent* event);
static gboolean ___lambda7__gsource_func (gpointer self);
static ECalComponentAlarmTrigger* _vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarm_free (ECalComponentAlarm* self);
static GTimeSpan maya_daemon_time_until_now (MayaDaemon* self,
                                      GDateTime* dt);
void maya_daemon_add_timeout (MayaDaemon* self,
                              ESource* source,
                              ECalComponent* event,
                              guint interval,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
void maya_daemon_add_timeout_finish (MayaDaemon* self,
                                     GAsyncResult* _res_);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void maya_daemon_add_timeout_data_free (gpointer _data);
static gboolean maya_daemon_add_timeout_co (MayaDaemonAddTimeoutData* _data_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block4Data* _data4_);
void maya_daemon_queue_event_notification (MayaDaemon* self,
                                           ECalComponent* event,
                                           const gchar* uid);
static gboolean ___lambda5__gsource_func (gpointer self);
MayaDaemon* maya_daemon_new (void);
MayaDaemon* maya_daemon_construct (GType object_type);
static GObject * maya_daemon_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _maya_daemon___lambda8_ (MayaDaemon* self);
static gboolean __maya_daemon___lambda8__gsource_func (gpointer self);
static void maya_daemon_finalize (GObject * obj);
static GType maya_daemon_get_type_once (void);
gint maya_main (gchar** args,
                gint args_length1);

const GOptionEntry MAYA_OPTIONS[2] = {{"debug", 'd', 0, G_OPTION_ARG_NONE, &maya_has_debug, N_ ("Print debug information"), NULL}, {NULL}};

static inline gpointer
maya_daemon_get_instance_private (MayaDaemon* self)
{
	return G_STRUCT_MEMBER_P (self, MayaDaemon_private_offset);
}

static void
maya_daemon_real_activate (GApplication* base)
{
	MayaDaemon * self;
	self = (MayaDaemon*) base;
	gtk_main ();
}

static void
_maya_daemon_on_events_added_calendar_event_store_events_added (CalendarEventStore* _sender,
                                                                ESource* source,
                                                                GeeCollection* events,
                                                                gpointer self)
{
	maya_daemon_on_events_added ((MayaDaemon*) self, source, events);
}

static void
_maya_daemon_on_events_updated_calendar_event_store_events_updated (CalendarEventStore* _sender,
                                                                    ESource* source,
                                                                    GeeCollection* events,
                                                                    gpointer self)
{
	maya_daemon_on_events_updated ((MayaDaemon*) self, source, events);
}

static void
_maya_daemon_on_events_removed_calendar_event_store_events_removed (CalendarEventStore* _sender,
                                                                    ESource* source,
                                                                    GeeCollection* events,
                                                                    gpointer self)
{
	maya_daemon_on_events_removed ((MayaDaemon*) self, source, events);
}

static void
maya_daemon_load_today_events (MayaDaemon* self)
{
	GeeHashMap* _tmp0_;
	CalendarEventStore* model = NULL;
	CalendarEventStore* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_hash_map_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->event_uid);
	self->priv->event_uid = _tmp0_;
	_tmp1_ = calendar_event_store_get_default ();
	model = _tmp1_;
	g_signal_connect_object (model, "events-added", (GCallback) _maya_daemon_on_events_added_calendar_event_store_events_added, self, 0);
	g_signal_connect_object (model, "events-updated", (GCallback) _maya_daemon_on_events_updated_calendar_event_store_events_updated, self, 0);
	g_signal_connect_object (model, "events-removed", (GCallback) _maya_daemon_on_events_removed_calendar_event_store_events_removed, self, 0);
	_tmp2_ = g_date_time_new_now_local ();
	_tmp3_ = calendar_util_datetime_get_start_of_month (_tmp2_);
	_tmp4_ = _tmp3_;
	calendar_event_store_set_month_start (model, _tmp4_);
	_g_date_time_unref0 (_tmp4_);
	_g_object_unref0 (model);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		MayaDaemon* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->source);
		_g_object_unref0 (_data1_->events);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
__lambda4_ (Block1Data* _data1_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
	self = _data1_->self;
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data1_->events);
		_event_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
			_tmp1_ = _event_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _event_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			event = (ECalComponent*) _tmp3_;
			_tmp4_ = event;
			maya_daemon_add_event (self, _data1_->source, _tmp4_);
			_g_object_unref0 (event);
		}
		_g_object_unref0 (_event_it);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
	return result;
}

static void
maya_daemon_on_events_added (MayaDaemon* self,
                             ESource* source,
                             GeeCollection* events)
{
	Block1Data* _data1_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp2_;
	ESourceAlarms* _tmp3_;
	ESourceAlarms* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (events != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (_data1_->source);
	_data1_->source = _tmp0_;
	_tmp1_ = _g_object_ref0 (events);
	_g_object_unref0 (_data1_->events);
	_data1_->events = _tmp1_;
	_tmp2_ = e_source_get_extension (_data1_->source, E_SOURCE_EXTENSION_ALARMS);
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, e_source_alarms_get_type (), ESourceAlarms));
	extension = _tmp3_;
	_tmp4_ = extension;
	if (e_source_alarms_get_include_me (_tmp4_) == FALSE) {
		_g_object_unref0 (extension);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	_g_object_unref0 (extension);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		MayaDaemon* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->source);
		_g_object_unref0 (_data2_->events);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
__lambda6_ (Block2Data* _data2_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
	self = _data2_->self;
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data2_->events);
		_event_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
			_tmp1_ = _event_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _event_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			event = (ECalComponent*) _tmp3_;
			_tmp4_ = event;
			maya_daemon_update_event (self, _data2_->source, _tmp4_);
			_g_object_unref0 (event);
		}
		_g_object_unref0 (_event_it);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
	return result;
}

static void
maya_daemon_on_events_updated (MayaDaemon* self,
                               ESource* source,
                               GeeCollection* events)
{
	Block2Data* _data2_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (events != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (_data2_->source);
	_data2_->source = _tmp0_;
	_tmp1_ = _g_object_ref0 (events);
	_g_object_unref0 (_data2_->events);
	_data2_->events = _tmp1_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block2_data_ref (_data2_), block2_data_unref);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		MayaDaemon* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->source);
		_g_object_unref0 (_data3_->events);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gboolean
__lambda7_ (Block3Data* _data3_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
	self = _data3_->self;
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data3_->events);
		_event_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
			_tmp1_ = _event_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _event_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			event = (ECalComponent*) _tmp3_;
			_tmp4_ = event;
			maya_daemon_remove_event (self, _data3_->source, _tmp4_);
			_g_object_unref0 (event);
		}
		_g_object_unref0 (_event_it);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ (self);
	return result;
}

static void
maya_daemon_on_events_removed (MayaDaemon* self,
                               ESource* source,
                               GeeCollection* events)
{
	Block3Data* _data3_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (events != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (_data3_->source);
	_data3_->source = _tmp0_;
	_tmp1_ = _g_object_ref0 (events);
	_g_object_unref0 (_data3_->events);
	_data3_->events = _tmp1_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, block3_data_ref (_data3_), block3_data_unref);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static ECalComponentAlarmTrigger*
_vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self)
{
	return g_boxed_copy (e_cal_component_alarm_trigger_get_type (), self);
}

static gpointer
__vala_ECalComponentAlarmTrigger_copy0 (gpointer self)
{
	return self ? _vala_ECalComponentAlarmTrigger_copy (self) : NULL;
}

static void
_vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self)
{
	g_boxed_free (e_cal_component_alarm_trigger_get_type (), self);
}

static void
_vala_ECalComponentAlarm_free (ECalComponentAlarm* self)
{
	g_boxed_free (e_cal_component_alarm_get_type (), self);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
maya_daemon_add_event (MayaDaemon* self,
                       ESource* source,
                       ECalComponent* event)
{
	ICalComponent* comp = NULL;
	ICalComponent* _tmp0_;
	ICalComponent* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ICalComponent* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GSList* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = e_cal_component_get_icalcomponent (event);
	comp = _tmp0_;
	_tmp1_ = comp;
	_tmp2_ = i_cal_component_get_summary (_tmp1_);
	_tmp3_ = e_source_dup_display_name (source);
	_tmp4_ = _tmp3_;
	_tmp5_ = comp;
	_tmp6_ = i_cal_component_get_uid (_tmp5_);
	_tmp7_ = g_strdup_printf ("Event [%s, %s, %s]", _tmp2_, _tmp4_, _tmp6_);
	_tmp8_ = _tmp7_;
	g_debug ("Daemon.vala:87: %s", _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp4_);
	_tmp9_ = e_cal_component_get_alarm_uids (event);
	{
		GSList* alarm_uid_collection = NULL;
		GSList* alarm_uid_it = NULL;
		alarm_uid_collection = _tmp9_;
		for (alarm_uid_it = alarm_uid_collection; alarm_uid_it != NULL; alarm_uid_it = alarm_uid_it->next) {
			gchar* _tmp10_;
			gchar* alarm_uid = NULL;
			_tmp10_ = g_strdup ((const gchar*) alarm_uid_it->data);
			alarm_uid = _tmp10_;
			{
				ECalComponentAlarm* e_alarm = NULL;
				const gchar* _tmp11_;
				ECalComponentAlarm* _tmp12_;
				ECalComponentAlarmAction action = 0;
				ECalComponentAlarm* _tmp13_;
				ECalComponentAlarmAction _tmp14_;
				_tmp11_ = alarm_uid;
				_tmp12_ = e_cal_component_get_alarm (event, _tmp11_);
				e_alarm = _tmp12_;
				_tmp13_ = e_alarm;
				action = e_cal_component_alarm_get_action (_tmp13_);
				_tmp14_ = action;
				switch (_tmp14_) {
					case E_CAL_COMPONENT_ALARM_DISPLAY:
					{
						ECalComponentAlarmTrigger* trigger = NULL;
						ECalComponentAlarm* _tmp15_;
						ECalComponentAlarmTrigger* _tmp16_;
						ECalComponentAlarmTrigger* _tmp17_;
						ECalComponentAlarmTrigger* _tmp18_;
						_tmp15_ = e_alarm;
						_tmp16_ = e_cal_component_alarm_get_trigger (_tmp15_);
						_tmp17_ = __vala_ECalComponentAlarmTrigger_copy0 (_tmp16_);
						__vala_ECalComponentAlarmTrigger_free0 (trigger);
						trigger = _tmp17_;
						_tmp18_ = trigger;
						if (e_cal_component_alarm_trigger_get_kind (_tmp18_) == E_CAL_COMPONENT_ALARM_TRIGGER_RELATIVE_START) {
							ICalDuration* duration = NULL;
							ECalComponentAlarmTrigger* _tmp19_;
							ICalDuration* _tmp20_;
							ICalDuration* _tmp21_;
							GDateTime* start_time = NULL;
							ICalComponent* _tmp22_;
							ICalTime* _tmp23_;
							ICalTime* _tmp24_;
							GDateTime* _tmp25_;
							GDateTime* _tmp26_;
							GDateTime* now = NULL;
							GDateTime* _tmp27_;
							GDateTime* _tmp28_;
							GDateTime* _tmp29_;
							GDateTime* _tmp30_;
							ICalDuration* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							ICalDuration* _tmp34_;
							GDateTime* _tmp35_;
							GDateTime* _tmp36_;
							ICalDuration* _tmp37_;
							GDateTime* _tmp38_;
							GDateTime* _tmp39_;
							ICalDuration* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
							ICalDuration* _tmp43_;
							GDateTime* _tmp44_;
							gboolean _tmp45_ = FALSE;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							_tmp19_ = trigger;
							_tmp20_ = e_cal_component_alarm_trigger_get_duration (_tmp19_);
							_tmp21_ = _g_object_ref0 (_tmp20_);
							duration = _tmp21_;
							_tmp22_ = comp;
							_tmp23_ = i_cal_component_get_dtstart (_tmp22_);
							_tmp24_ = _tmp23_;
							_tmp25_ = calendar_util_icaltime_to_datetime (_tmp24_);
							_tmp26_ = _tmp25_;
							_g_object_unref0 (_tmp24_);
							start_time = _tmp26_;
							_tmp27_ = g_date_time_new_now_local ();
							now = _tmp27_;
							_tmp28_ = now;
							_tmp29_ = start_time;
							if (g_date_time_compare (_tmp28_, _tmp29_) > 0) {
								_g_date_time_unref0 (now);
								_g_date_time_unref0 (start_time);
								_g_object_unref0 (duration);
								__vala_ECalComponentAlarmTrigger_free0 (trigger);
								__vala_ECalComponentAlarm_free0 (e_alarm);
								_g_free0 (alarm_uid);
								continue;
							}
							_tmp30_ = start_time;
							_tmp31_ = duration;
							_tmp32_ = g_date_time_add_weeks (_tmp30_, -((gint) i_cal_duration_get_weeks (_tmp31_)));
							_g_date_time_unref0 (start_time);
							start_time = _tmp32_;
							_tmp33_ = start_time;
							_tmp34_ = duration;
							_tmp35_ = g_date_time_add_days (_tmp33_, -((gint) i_cal_duration_get_days (_tmp34_)));
							_g_date_time_unref0 (start_time);
							start_time = _tmp35_;
							_tmp36_ = start_time;
							_tmp37_ = duration;
							_tmp38_ = g_date_time_add_hours (_tmp36_, -((gint) i_cal_duration_get_hours (_tmp37_)));
							_g_date_time_unref0 (start_time);
							start_time = _tmp38_;
							_tmp39_ = start_time;
							_tmp40_ = duration;
							_tmp41_ = g_date_time_add_minutes (_tmp39_, -((gint) i_cal_duration_get_minutes (_tmp40_)));
							_g_date_time_unref0 (start_time);
							start_time = _tmp41_;
							_tmp42_ = start_time;
							_tmp43_ = duration;
							_tmp44_ = g_date_time_add_seconds (_tmp42_, (gdouble) (-((gint) i_cal_duration_get_seconds (_tmp43_))));
							_g_date_time_unref0 (start_time);
							start_time = _tmp44_;
							_tmp46_ = start_time;
							_tmp47_ = now;
							if (g_date_time_get_year (_tmp46_) == g_date_time_get_year (_tmp47_)) {
								GDateTime* _tmp48_;
								GDateTime* _tmp49_;
								_tmp48_ = start_time;
								_tmp49_ = now;
								_tmp45_ = g_date_time_get_day_of_year (_tmp48_) == g_date_time_get_day_of_year (_tmp49_);
							} else {
								_tmp45_ = FALSE;
							}
							if (_tmp45_) {
								GTimeSpan time = 0LL;
								GDateTime* _tmp50_;
								_tmp50_ = start_time;
								time = maya_daemon_time_until_now (self, _tmp50_);
								if (time >= ((GTimeSpan) 0)) {
									maya_daemon_add_timeout (self, source, event, (guint) time, NULL, NULL);
								}
							}
							_g_date_time_unref0 (now);
							_g_date_time_unref0 (start_time);
							_g_object_unref0 (duration);
						}
						__vala_ECalComponentAlarmTrigger_free0 (trigger);
						__vala_ECalComponentAlarm_free0 (e_alarm);
						_g_free0 (alarm_uid);
						continue;
					}
					default:
					{
						__vala_ECalComponentAlarm_free0 (e_alarm);
						_g_free0 (alarm_uid);
						continue;
					}
				}
				__vala_ECalComponentAlarm_free0 (e_alarm);
				_g_free0 (alarm_uid);
			}
		}
		(alarm_uid_collection == NULL) ? NULL : (alarm_uid_collection = (_g_slist_free__g_free0_ (alarm_uid_collection), NULL));
	}
}

static void
maya_daemon_add_timeout_data_free (gpointer _data)
{
	MayaDaemonAddTimeoutData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MayaDaemonAddTimeoutData, _data_);
}

void
maya_daemon_add_timeout (MayaDaemon* self,
                         ESource* source,
                         ECalComponent* event,
                         guint interval,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	MayaDaemonAddTimeoutData* _data_;
	MayaDaemon* _tmp0_;
	ESource* _tmp1_;
	ECalComponent* _tmp2_;
	_data_ = g_slice_new0 (MayaDaemonAddTimeoutData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, maya_daemon_add_timeout_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (source);
	_g_object_unref0 (_data_->source);
	_data_->source = _tmp1_;
	_tmp2_ = _g_object_ref0 (event);
	_g_object_unref0 (_data_->event);
	_data_->event = _tmp2_;
	_data_->interval = interval;
	maya_daemon_add_timeout_co (_data_);
}

void
maya_daemon_add_timeout_finish (MayaDaemon* self,
                                GAsyncResult* _res_)
{
	MayaDaemonAddTimeoutData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		MayaDaemon* self;
		self = _data4_->self;
		_g_free0 (_data4_->uid);
		_g_object_unref0 (_data4_->source);
		_g_object_unref0 (_data4_->event);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gboolean
__lambda5_ (Block4Data* _data4_)
{
	MayaDaemon* self;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp0_;
	ESourceAlarms* _tmp1_;
	ESourceAlarms* _tmp2_;
	gboolean result = FALSE;
	self = _data4_->self;
	_tmp0_ = e_source_get_extension (_data4_->source, E_SOURCE_EXTENSION_ALARMS);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_alarms_get_type (), ESourceAlarms));
	extension = _tmp1_;
	_tmp2_ = extension;
	if (_tmp2_ != NULL) {
		ESourceAlarms* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp3_ = extension;
		_tmp4_ = g_date_time_new_now_local ();
		_tmp5_ = _tmp4_;
		_tmp6_ = g_date_time_to_string (_tmp5_);
		_tmp7_ = _tmp6_;
		e_source_alarms_set_last_notified (_tmp3_, _tmp7_);
		_g_free0 (_tmp7_);
		_g_date_time_unref0 (_tmp5_);
	}
	maya_daemon_queue_event_notification (self, _data4_->event, _data4_->uid);
	result = FALSE;
	_g_object_unref0 (extension);
	return result;
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
	return result;
}

static gboolean
maya_daemon_add_timeout_co (MayaDaemonAddTimeoutData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data4_ = g_slice_new0 (Block4Data);
	_data_->_data4_->_ref_count_ = 1;
	_data_->_data4_->self = g_object_ref (_data_->self);
	_g_object_unref0 (_data_->_data4_->source);
	_data_->_data4_->source = _data_->source;
	_g_object_unref0 (_data_->_data4_->event);
	_data_->_data4_->event = _data_->event;
	_data_->_data4_->_async_data_ = _data_;
	_data_->_tmp0_ = g_strdup_printf ("%u-%u", _data_->interval, (guint) g_random_int ());
	_data_->_data4_->uid = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->self->priv->event_uid;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp1_, _data_->_data4_->event, _data_->_data4_->uid);
	g_debug ("Daemon.vala:134: adding timeout uid:%s", _data_->_data4_->uid);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _data_->interval, ___lambda5__gsource_func, block4_data_ref (_data_->_data4_), block4_data_unref);
	block4_data_unref (_data_->_data4_);
	_data_->_data4_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

void
maya_daemon_queue_event_notification (MayaDaemon* self,
                                      ECalComponent* event,
                                      const gchar* uid)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	ICalComponent* comp = NULL;
	ICalComponent* _tmp5_;
	gchar* primary_text = NULL;
	ICalComponent* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GDateTime* start_time = NULL;
	ICalComponent* _tmp9_;
	ICalTime* _tmp10_;
	ICalTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* now = NULL;
	GDateTime* _tmp14_;
	gchar* secondary_text = NULL;
	gchar* _tmp15_;
	GSettings* h24_settings = NULL;
	GSettings* _tmp16_;
	gchar* format = NULL;
	GSettings* _tmp17_;
	gchar* _tmp18_;
	gchar* text = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GDateTime* _tmp21_;
	GDateTime* _tmp22_;
	GNotification* notification = NULL;
	const gchar* _tmp41_;
	GNotification* _tmp42_;
	GNotification* _tmp43_;
	const gchar* _tmp44_;
	GNotification* _tmp45_;
	GThemedIcon* _tmp46_;
	GThemedIcon* _tmp47_;
	GApplication* _tmp48_;
	GNotification* _tmp49_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	g_return_if_fail (uid != NULL);
	_tmp0_ = self->priv->event_uid;
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_contains (_tmp3_, uid) == FALSE;
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		return;
	}
	_tmp5_ = e_cal_component_get_icalcomponent (event);
	comp = _tmp5_;
	_tmp6_ = comp;
	_tmp7_ = i_cal_component_get_summary (_tmp6_);
	_tmp8_ = g_strdup_printf ("%s", _tmp7_);
	primary_text = _tmp8_;
	_tmp9_ = comp;
	_tmp10_ = i_cal_component_get_dtstart (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = calendar_util_icaltime_to_datetime (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp11_);
	start_time = _tmp13_;
	_tmp14_ = g_date_time_new_now_local ();
	now = _tmp14_;
	_tmp15_ = g_strdup ("");
	secondary_text = _tmp15_;
	_tmp16_ = g_settings_new ("org.gnome.desktop.interface");
	h24_settings = _tmp16_;
	_tmp17_ = h24_settings;
	_tmp18_ = g_settings_get_string (_tmp17_, "clock-format");
	format = _tmp18_;
	_tmp19_ = format;
	_tmp20_ = granite_date_time_get_default_time_format (string_contains (_tmp19_, "12h"), FALSE);
	text = _tmp20_;
	_tmp21_ = start_time;
	_tmp22_ = now;
	if (g_date_time_get_year (_tmp21_) == g_date_time_get_year (_tmp22_)) {
		GDateTime* _tmp23_;
		GDateTime* _tmp24_;
		_tmp23_ = start_time;
		_tmp24_ = now;
		if (g_date_time_get_day_of_year (_tmp23_) == g_date_time_get_day_of_year (_tmp24_)) {
			GDateTime* _tmp25_;
			gchar* _tmp26_;
			_tmp25_ = start_time;
			_tmp26_ = granite_date_time_get_relative_datetime (_tmp25_);
			_g_free0 (secondary_text);
			secondary_text = _tmp26_;
		} else {
			GDateTime* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			_tmp27_ = start_time;
			_tmp28_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
			_tmp29_ = _tmp28_;
			_tmp30_ = text;
			_tmp31_ = g_strdup_printf ("%s, %s", _tmp29_, _tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = g_date_time_format (_tmp27_, _tmp32_);
			_g_free0 (secondary_text);
			secondary_text = _tmp33_;
			_g_free0 (_tmp32_);
			_g_free0 (_tmp29_);
		}
	} else {
		GDateTime* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		_tmp34_ = start_time;
		_tmp35_ = granite_date_time_get_default_date_format (FALSE, TRUE, TRUE);
		_tmp36_ = _tmp35_;
		_tmp37_ = text;
		_tmp38_ = g_strdup_printf ("%s, %s", _tmp36_, _tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = g_date_time_format (_tmp34_, _tmp39_);
		_g_free0 (secondary_text);
		secondary_text = _tmp40_;
		_g_free0 (_tmp39_);
		_g_free0 (_tmp36_);
	}
	_tmp41_ = primary_text;
	_tmp42_ = g_notification_new (_tmp41_);
	notification = _tmp42_;
	_tmp43_ = notification;
	_tmp44_ = secondary_text;
	g_notification_set_body (_tmp43_, _tmp44_);
	_tmp45_ = notification;
	_tmp46_ = (GThemedIcon*) g_themed_icon_new ("office-calendar");
	_tmp47_ = _tmp46_;
	g_notification_set_icon (_tmp45_, (GIcon*) _tmp47_);
	_g_object_unref0 (_tmp47_);
	_tmp48_ = g_application_get_default ();
	_tmp49_ = notification;
	g_application_send_notification (_tmp48_, uid, _tmp49_);
	_g_object_unref0 (notification);
	_g_free0 (text);
	_g_free0 (format);
	_g_object_unref0 (h24_settings);
	_g_free0 (secondary_text);
	_g_date_time_unref0 (now);
	_g_date_time_unref0 (start_time);
	_g_free0 (primary_text);
}

static void
maya_daemon_update_event (MayaDaemon* self,
                          ESource* source,
                          ECalComponent* event)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (event != NULL);
	maya_daemon_remove_event (self, source, event);
	e_cal_component_commit_sequence (event);
	maya_daemon_add_event (self, source, event);
}

static void
maya_daemon_remove_event (MayaDaemon* self,
                          ESource* source,
                          ECalComponent* event)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = self->priv->event_uid;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, event)) {
		GeeHashMap* _tmp1_;
		_tmp1_ = self->priv->event_uid;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, event, NULL);
	}
}

static GTimeSpan
maya_daemon_time_until_now (MayaDaemon* self,
                            GDateTime* dt)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	g_return_val_if_fail (dt != NULL, 0LL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	result = g_date_time_difference (dt, now) / G_TIME_SPAN_SECOND;
	_g_date_time_unref0 (now);
	return result;
}

MayaDaemon*
maya_daemon_construct (GType object_type)
{
	MayaDaemon * self = NULL;
	self = (MayaDaemon*) g_object_new (object_type, NULL);
	return self;
}

MayaDaemon*
maya_daemon_new (void)
{
	return maya_daemon_construct (MAYA_TYPE_DAEMON);
}

static gboolean
_maya_daemon___lambda8_ (MayaDaemon* self)
{
	GeeHashMap* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->event_uid;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	maya_daemon_load_today_events (self);
	result = TRUE;
	return result;
}

static gboolean
__maya_daemon___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = _maya_daemon___lambda8_ ((MayaDaemon*) self);
	return result;
}

static GObject *
maya_daemon_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MayaDaemon * self;
	parent_class = G_OBJECT_CLASS (maya_daemon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_DAEMON, MayaDaemon);
	maya_daemon_load_today_events (self);
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 86400, __maya_daemon___lambda8__gsource_func, g_object_ref (self), g_object_unref);
	return obj;
}

static void
maya_daemon_class_init (MayaDaemonClass * klass,
                        gpointer klass_data)
{
	maya_daemon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MayaDaemon_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) maya_daemon_real_activate;
	G_OBJECT_CLASS (klass)->constructor = maya_daemon_constructor;
	G_OBJECT_CLASS (klass)->finalize = maya_daemon_finalize;
}

static void
maya_daemon_instance_init (MayaDaemon * self,
                           gpointer klass)
{
	self->priv = maya_daemon_get_instance_private (self);
}

static void
maya_daemon_finalize (GObject * obj)
{
	MayaDaemon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_DAEMON, MayaDaemon);
	_g_object_unref0 (self->priv->event_uid);
	G_OBJECT_CLASS (maya_daemon_parent_class)->finalize (obj);
}

static GType
maya_daemon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaDaemonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_daemon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaDaemon), 0, (GInstanceInitFunc) maya_daemon_instance_init, NULL };
	GType maya_daemon_type_id;
	maya_daemon_type_id = g_type_register_static (g_application_get_type (), "MayaDaemon", &g_define_type_info, 0);
	MayaDaemon_private_offset = g_type_add_instance_private (maya_daemon_type_id, sizeof (MayaDaemonPrivate));
	return maya_daemon_type_id;
}

GType
maya_daemon_get_type (void)
{
	static volatile gsize maya_daemon_type_id__volatile = 0;
	if (g_once_init_enter (&maya_daemon_type_id__volatile)) {
		GType maya_daemon_type_id;
		maya_daemon_type_id = maya_daemon_get_type_once ();
		g_once_init_leave (&maya_daemon_type_id__volatile, maya_daemon_type_id);
	}
	return maya_daemon_type_id__volatile;
}

gint
maya_main (gchar** args,
           gint args_length1)
{
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	MayaDaemon* app = NULL;
	MayaDaemon* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint result = 0;
	_tmp0_ = g_option_context_new ("");
	context = _tmp0_;
	g_option_context_add_main_entries (context, MAYA_OPTIONS, NULL);
	{
		g_option_context_parse (context, (gint*) (&args_length1), &args, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp1_ = -1;
			if (_inner_error0_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e->message;
		g_error ("Daemon.vala:204: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp3_ = -1;
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp3_;
	}
	granite_services_logger_initialize (BUILD_APP_NAME);
	granite_services_logger_set_DisplayLevel (GRANITE_SERVICES_LOG_LEVEL_WARN);
	if (maya_has_debug) {
		granite_services_logger_set_DisplayLevel (GRANITE_SERVICES_LOG_LEVEL_DEBUG);
	}
	_tmp4_ = maya_daemon_new ();
	app = _tmp4_;
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
	_g_object_unref0 (app);
	_g_option_context_free0 (context);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return maya_main (argv, argc);
}

