/* SourceDialog.c generated by valac 0.48.11, the Vala compiler
 * generated from SourceDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Jaap Broekhuizen
 *              Corentin Noël <corentin@elementaryos.org>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "elementary-calendar.h"
#include <gee.h>
#include <libedataserver/libedataserver.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define MAYA_VIEW_TYPE_SOURCE_DIALOG (maya_view_source_dialog_get_type ())
#define MAYA_VIEW_SOURCE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog))
#define MAYA_VIEW_SOURCE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialogClass))
#define MAYA_VIEW_IS_SOURCE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG))
#define MAYA_VIEW_IS_SOURCE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_VIEW_TYPE_SOURCE_DIALOG))
#define MAYA_VIEW_SOURCE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialogClass))

typedef struct _MayaViewSourceDialog MayaViewSourceDialog;
typedef struct _MayaViewSourceDialogClass MayaViewSourceDialogClass;
typedef struct _MayaViewSourceDialogPrivate MayaViewSourceDialogPrivate;
typedef enum  {
	MAYA_VIEW_EVENT_TYPE_ADD,
	MAYA_VIEW_EVENT_TYPE_EDIT
} MayaViewEventType;

#define MAYA_VIEW_TYPE_EVENT_TYPE (maya_view_event_type_get_type ())
enum  {
	MAYA_VIEW_SOURCE_DIALOG_0_PROPERTY,
	MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY,
	MAYA_VIEW_SOURCE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block21Data Block21Data;
enum  {
	MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL,
	MAYA_VIEW_SOURCE_DIALOG_NUM_SIGNALS
};
static guint maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_NUM_SIGNALS] = {0};

struct _MayaViewSourceDialog {
	GtkGrid parent_instance;
	MayaViewSourceDialogPrivate * priv;
};

struct _MayaViewSourceDialogClass {
	GtkGridClass parent_class;
};

struct _MayaViewSourceDialogPrivate {
	MayaViewEventType _event_type;
	GtkEntry* name_entry;
	gchar* hex_color;
	MayaBackend* current_backend;
	GeeCollection* backend_widgets;
	GtkGrid* main_grid;
	GeeHashMap* widgets_checked;
	GtkButton* create_button;
	GtkComboBox* type_combobox;
	GtkListStore* list_store;
	GtkCheckButton* is_default_check;
	ESource* source;
	GtkRadioButton* color_button_red;
	GtkRadioButton* color_button_orange;
	GtkRadioButton* color_button_yellow;
	GtkRadioButton* color_button_green;
	GtkRadioButton* color_button_blue;
	GtkRadioButton* color_button_purple;
	GtkRadioButton* color_button_brown;
	GtkRadioButton* color_button_slate;
	GtkRadioButton* color_button_none;
};

struct _Block21Data {
	int _ref_count_;
	MayaViewSourceDialog* self;
	MayaPlacementWidget* widget;
};

static gint MayaViewSourceDialog_private_offset;
static gpointer maya_view_source_dialog_parent_class = NULL;

GType maya_view_source_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaViewSourceDialog, g_object_unref)
GType maya_view_event_type_get_type (void) G_GNUC_CONST;
void maya_view_source_dialog_set_source (MayaViewSourceDialog* self,
                                         ESource* source);
static void maya_view_source_dialog_set_event_type (MayaViewSourceDialog* self,
                                             MayaViewEventType value);
static gboolean maya_view_source_dialog_tree_foreach (MayaViewSourceDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter);
static gboolean _maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self);
static void maya_view_source_dialog_remove_backend_widgets (MayaViewSourceDialog* self);
static void maya_view_source_dialog_add_backend_widgets (MayaViewSourceDialog* self);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static void _____lambda156_ (Block21Data* _data21_);
static void maya_view_source_dialog_entry_changed (MayaViewSourceDialog* self,
                                            MayaPlacementWidget* widget);
static void ______lambda156__gtk_editable_changed (GtkEditable* _sender,
                                            gpointer self);
static void maya_view_source_dialog_check_can_validate (MayaViewSourceDialog* self);
void maya_view_source_dialog_save (MayaViewSourceDialog* self);
MayaViewEventType maya_view_source_dialog_get_event_type (MayaViewSourceDialog* self);
MayaViewSourceDialog* maya_view_source_dialog_new (void);
MayaViewSourceDialog* maya_view_source_dialog_construct (GType object_type);
static GObject * maya_view_source_dialog_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _maya_view_source_dialog_save_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _maya_view_source_dialog___lambda157_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda157__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _maya_view_source_dialog___lambda158_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda158__gtk_editable_changed (GtkEditable* _sender,
                                                                  gpointer self);
static void _maya_view_source_dialog___lambda159_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda159__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self);
static void _maya_view_source_dialog___lambda160_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda160__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda161_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda161__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda162_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda162__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda163_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda163__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda164_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda164__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda165_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda165__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda166_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda166__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _maya_view_source_dialog___lambda167_ (MayaViewSourceDialog* self);
static void __maya_view_source_dialog___lambda167__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void maya_view_source_dialog_finalize (GObject * obj);
static GType maya_view_source_dialog_get_type_once (void);
static void _vala_maya_view_source_dialog_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_maya_view_source_dialog_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
maya_view_source_dialog_get_instance_private (MayaViewSourceDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MayaViewSourceDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                   GtkTreePath* path,
                                                                   GtkTreeIter* iter,
                                                                   gpointer self)
{
	gboolean result;
	result = maya_view_source_dialog_tree_foreach ((MayaViewSourceDialog*) self, model, path, iter);
	return result;
}

void
maya_view_source_dialog_set_source (MayaViewSourceDialog* self,
                                    ESource* source)
{
	ESource* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (self->priv->source);
	self->priv->source = _tmp0_;
	if (source == NULL) {
		GtkEntry* _tmp1_;
		GtkComboBox* _tmp2_;
		GtkRadioButton* _tmp3_;
		GtkButton* _tmp4_;
		GtkCheckButton* _tmp5_;
		GtkCheckButton* _tmp6_;
		maya_view_source_dialog_set_event_type (self, MAYA_VIEW_EVENT_TYPE_ADD);
		_tmp1_ = self->priv->name_entry;
		gtk_entry_set_text (_tmp1_, "");
		_tmp2_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
		_tmp3_ = self->priv->color_button_red;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
		_tmp4_ = self->priv->create_button;
		gtk_button_set_label (_tmp4_, _ ("Create Calendar"));
		_tmp5_ = self->priv->is_default_check;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
		_tmp6_ = self->priv->is_default_check;
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp6_, FALSE);
	} else {
		GtkButton* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		GtkComboBox* _tmp11_;
		GtkComboBox* _tmp12_;
		GtkListStore* _tmp13_;
		ESourceCalendar* cal = NULL;
		ESourceExtension* _tmp24_;
		ESourceCalendar* _tmp25_;
		ESourceCalendar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GQuark _tmp30_ = 0U;
		static GQuark _tmp29_label0 = 0;
		static GQuark _tmp29_label1 = 0;
		static GQuark _tmp29_label2 = 0;
		static GQuark _tmp29_label3 = 0;
		static GQuark _tmp29_label4 = 0;
		static GQuark _tmp29_label5 = 0;
		static GQuark _tmp29_label6 = 0;
		static GQuark _tmp29_label7 = 0;
		maya_view_source_dialog_set_event_type (self, MAYA_VIEW_EVENT_TYPE_EDIT);
		_tmp7_ = self->priv->create_button;
		gtk_button_set_label (_tmp7_, _ ("Save"));
		_tmp8_ = self->priv->name_entry;
		_tmp9_ = e_source_get_display_name (source);
		_tmp10_ = _tmp9_;
		gtk_entry_set_text (_tmp8_, _tmp10_);
		_tmp11_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
		_tmp12_ = self->priv->type_combobox;
		gtk_combo_box_set_active (_tmp12_, 0);
		_tmp13_ = self->priv->list_store;
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp13_, _maya_view_source_dialog_tree_foreach_gtk_tree_model_foreach_func, self);
		{
			ESourceRegistry* registry = NULL;
			ESourceRegistry* _tmp14_;
			gboolean source_is_default = FALSE;
			ESourceRegistry* _tmp15_;
			ESource* _tmp16_;
			ESource* _tmp17_;
			ESource* _tmp18_;
			gboolean _tmp19_;
			GtkCheckButton* _tmp20_;
			GtkCheckButton* _tmp21_;
			_tmp14_ = e_source_registry_new_sync (NULL, &_inner_error0_);
			registry = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp15_ = registry;
			g_object_get (_tmp15_, "default-calendar", &_tmp16_, NULL);
			_tmp17_ = _tmp16_;
			_tmp18_ = _tmp17_;
			_tmp19_ = e_source_equal (source, _tmp18_);
			_g_object_unref0 (_tmp18_);
			source_is_default = _tmp19_;
			_tmp20_ = self->priv->is_default_check;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, !source_is_default);
			_tmp21_ = self->priv->is_default_check;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp21_, source_is_default);
			_g_object_unref0 (registry);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp22_;
			const gchar* _tmp23_;
			_error_ = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp22_ = _error_;
			_tmp23_ = _tmp22_->message;
			g_critical ("SourceDialog.vala:262: %s", _tmp23_);
			_g_error_free0 (_error_);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp24_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
		_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, e_source_calendar_get_type (), ESourceCalendar));
		cal = _tmp25_;
		_tmp26_ = cal;
		_tmp27_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp26_);
		_tmp28_ = _tmp27_;
		_tmp30_ = (NULL == _tmp28_) ? 0 : g_quark_from_string (_tmp28_);
		g_free (_tmp28_);
		if (_tmp30_ == ((0 != _tmp29_label0) ? _tmp29_label0 : (_tmp29_label0 = g_quark_from_static_string ("#da3d41")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp31_;
					_tmp31_ = self->priv->color_button_red;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp31_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label1) ? _tmp29_label1 : (_tmp29_label1 = g_quark_from_static_string ("#f37329")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp32_;
					_tmp32_ = self->priv->color_button_orange;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp32_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label2) ? _tmp29_label2 : (_tmp29_label2 = g_quark_from_static_string ("#e6a92a")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp33_;
					_tmp33_ = self->priv->color_button_yellow;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp33_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label3) ? _tmp29_label3 : (_tmp29_label3 = g_quark_from_static_string ("#81c837")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp34_;
					_tmp34_ = self->priv->color_button_green;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp34_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label4) ? _tmp29_label4 : (_tmp29_label4 = g_quark_from_static_string ("#3689e6")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp35_;
					_tmp35_ = self->priv->color_button_blue;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp35_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label5) ? _tmp29_label5 : (_tmp29_label5 = g_quark_from_static_string ("#a56de2")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp36_;
					_tmp36_ = self->priv->color_button_purple;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp36_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label6) ? _tmp29_label6 : (_tmp29_label6 = g_quark_from_static_string ("#8a715e")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp37_;
					_tmp37_ = self->priv->color_button_brown;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp37_, TRUE);
					break;
				}
			}
		} else if (_tmp30_ == ((0 != _tmp29_label7) ? _tmp29_label7 : (_tmp29_label7 = g_quark_from_static_string ("#667885")))) {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp38_;
					_tmp38_ = self->priv->color_button_slate;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp38_, TRUE);
					break;
				}
			}
		} else {
			switch (0) {
				default:
				{
					GtkRadioButton* _tmp39_;
					ESourceCalendar* _tmp40_;
					gchar* _tmp41_;
					_tmp39_ = self->priv->color_button_none;
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp39_, TRUE);
					_tmp40_ = cal;
					_tmp41_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp40_);
					_g_free0 (self->priv->hex_color);
					self->priv->hex_color = _tmp41_;
					break;
				}
			}
		}
		_g_object_unref0 (cal);
	}
}

static gboolean
maya_view_source_dialog_tree_foreach (MayaViewSourceDialog* self,
                                      GtkTreeModel* model,
                                      GtkTreePath* path,
                                      GtkTreeIter* iter)
{
	GValue backend = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	MayaBackend* current_backend = NULL;
	GValue _tmp3_;
	MayaBackend* _tmp4_;
	MayaBackend* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ESource* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, 1, &_tmp2_);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	backend = _tmp2_;
	_tmp3_ = backend;
	_tmp4_ = _g_object_ref0 (g_value_get_object (&_tmp3_));
	current_backend = _tmp4_;
	_tmp5_ = current_backend;
	_tmp6_ = maya_backend_get_uid (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->source;
	_tmp9_ = e_source_dup_parent (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strcmp0 (_tmp7_, _tmp10_) == 0;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp7_);
	if (_tmp11_) {
		GtkComboBox* _tmp12_;
		GtkTreeIter _tmp13_;
		GtkComboBox* _tmp14_;
		_tmp12_ = self->priv->type_combobox;
		_tmp13_ = *iter;
		gtk_combo_box_set_active_iter (_tmp12_, &_tmp13_);
		_tmp14_ = self->priv->type_combobox;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
		result = TRUE;
		_g_object_unref0 (current_backend);
		G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
		return result;
	}
	result = FALSE;
	_g_object_unref0 (current_backend);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	return result;
}

static void
maya_view_source_dialog_remove_backend_widgets (MayaViewSourceDialog* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backend_widgets;
	if (_tmp0_ == NULL) {
		return;
	}
	{
		GeeIterator* _widget_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->backend_widgets;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_widget_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MayaPlacementWidget* widget = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MayaPlacementWidget* _tmp6_;
			GtkWidget* _tmp7_;
			MayaPlacementWidget* _tmp8_;
			GtkWidget* _tmp9_;
			_tmp3_ = _widget_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _widget_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			widget = (MayaPlacementWidget*) _tmp5_;
			_tmp6_ = widget;
			_tmp7_ = _tmp6_->widget;
			gtk_widget_hide (_tmp7_);
			_tmp8_ = widget;
			_tmp9_ = _tmp8_->widget;
			gtk_widget_destroy (_tmp9_);
			_g_object_unref0 (widget);
		}
		_g_object_unref0 (_widget_it);
	}
	_tmp10_ = self->priv->backend_widgets;
	gee_collection_clear (_tmp10_);
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
	g_atomic_int_inc (&_data21_->_ref_count_);
	return _data21_;
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
		MayaViewSourceDialog* self;
		self = _data21_->self;
		_g_object_unref0 (_data21_->widget);
		_g_object_unref0 (self);
		g_slice_free (Block21Data, _data21_);
	}
}

static void
_____lambda156_ (Block21Data* _data21_)
{
	MayaViewSourceDialog* self;
	MayaPlacementWidget* _tmp0_;
	self = _data21_->self;
	_tmp0_ = _data21_->widget;
	maya_view_source_dialog_entry_changed (self, _tmp0_);
}

static void
______lambda156__gtk_editable_changed (GtkEditable* _sender,
                                       gpointer self)
{
	_____lambda156_ (self);
}

static void
maya_view_source_dialog_add_backend_widgets (MayaViewSourceDialog* self)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->widgets_checked;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	{
		GeeIterator* _widget_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = self->priv->backend_widgets;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_widget_it = _tmp2_;
		while (TRUE) {
			Block21Data* _data21_;
			GeeIterator* _tmp3_;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GtkGrid* _tmp6_;
			MayaPlacementWidget* _tmp7_;
			GtkWidget* _tmp8_;
			MayaPlacementWidget* _tmp9_;
			MayaPlacementWidget* _tmp10_;
			gboolean _tmp11_ = FALSE;
			MayaPlacementWidget* _tmp12_;
			MayaPlacementWidget* _tmp26_;
			GtkWidget* _tmp27_;
			_data21_ = g_slice_new0 (Block21Data);
			_data21_->_ref_count_ = 1;
			_data21_->self = g_object_ref (self);
			_tmp3_ = _widget_it;
			if (!gee_iterator_next (_tmp3_)) {
				block21_data_unref (_data21_);
				_data21_ = NULL;
				break;
			}
			_tmp4_ = _widget_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			_data21_->widget = (MayaPlacementWidget*) _tmp5_;
			_tmp6_ = self->priv->main_grid;
			_tmp7_ = _data21_->widget;
			_tmp8_ = _tmp7_->widget;
			_tmp9_ = _data21_->widget;
			_tmp10_ = _data21_->widget;
			gtk_grid_attach (_tmp6_, _tmp8_, _tmp9_->column, 4 + _tmp10_->row, 1, 1);
			_tmp12_ = _data21_->widget;
			if (_tmp12_->needed == TRUE) {
				MayaPlacementWidget* _tmp13_;
				GtkWidget* _tmp14_;
				_tmp13_ = _data21_->widget;
				_tmp14_ = _tmp13_->widget;
				_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_entry_get_type ());
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				GtkEntry* entry = NULL;
				MayaPlacementWidget* _tmp15_;
				GtkWidget* _tmp16_;
				GtkEntry* _tmp17_;
				GtkEntry* _tmp18_;
				GeeHashMap* _tmp19_;
				MayaPlacementWidget* _tmp20_;
				const gchar* _tmp21_;
				MayaPlacementWidget* _tmp22_;
				GtkWidget* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				_tmp15_ = _data21_->widget;
				_tmp16_ = _tmp15_->widget;
				_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp16_) : NULL);
				entry = _tmp17_;
				_tmp18_ = entry;
				g_signal_connect_data ((GtkEditable*) _tmp18_, "changed", (GCallback) ______lambda156__gtk_editable_changed, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
				_tmp19_ = self->priv->widgets_checked;
				_tmp20_ = _data21_->widget;
				_tmp21_ = _tmp20_->ref_name;
				_tmp22_ = _data21_->widget;
				_tmp23_ = _tmp22_->widget;
				_tmp24_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_entry_get_type (), GtkEntry));
				_tmp25_ = _tmp24_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, _tmp21_, (gpointer) ((gintptr) (g_strcmp0 (_tmp25_, "") != 0)));
				_g_object_unref0 (entry);
			}
			_tmp26_ = _data21_->widget;
			_tmp27_ = _tmp26_->widget;
			gtk_widget_show (_tmp27_);
			block21_data_unref (_data21_);
			_data21_ = NULL;
		}
		_g_object_unref0 (_widget_it);
	}
	maya_view_source_dialog_check_can_validate (self);
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strchug (_result_);
	result = _result_;
	return result;
}

static void
maya_view_source_dialog_entry_changed (MayaViewSourceDialog* self,
                                       MayaPlacementWidget* widget)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	GtkWidget* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->widgets_checked;
	_tmp1_ = widget->ref_name;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp1_, NULL);
	_tmp2_ = self->priv->widgets_checked;
	_tmp3_ = widget->ref_name;
	_tmp4_ = widget->widget;
	_tmp5_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_entry_get_type (), GtkEntry));
	_tmp6_ = _tmp5_;
	_tmp7_ = string_chug (_tmp6_);
	_tmp8_ = _tmp7_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, _tmp3_, (gpointer) ((gintptr) (g_utf8_strlen (_tmp8_, (gssize) -1) > 0)));
	_g_free0 (_tmp8_);
	maya_view_source_dialog_check_can_validate (self);
}

static void
maya_view_source_dialog_check_can_validate (MayaViewSourceDialog* self)
{
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _valid_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->widgets_checked;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_valid_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean valid = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			_tmp6_ = _valid_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _valid_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			valid = (gboolean) ((gintptr) _tmp8_);
			if (valid == FALSE) {
				GtkButton* _tmp9_;
				_tmp9_ = self->priv->create_button;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
				_g_object_unref0 (_valid_it);
				return;
			}
		}
		_g_object_unref0 (_valid_it);
	}
	_tmp10_ = self->priv->name_entry;
	_tmp11_ = gtk_entry_get_text (_tmp10_);
	_tmp12_ = _tmp11_;
	if (g_strcmp0 (_tmp12_, "") != 0) {
		GtkButton* _tmp13_;
		_tmp13_ = self->priv->create_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
	}
}

void
maya_view_source_dialog_save (MayaViewSourceDialog* self)
{
	MayaViewEventType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_event_type;
	if (_tmp0_ == MAYA_VIEW_EVENT_TYPE_ADD) {
		MayaBackend* _tmp1_;
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GtkCheckButton* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		GeeCollection* _tmp9_;
		_tmp1_ = self->priv->current_backend;
		_tmp2_ = self->priv->name_entry;
		_tmp3_ = gtk_entry_get_text (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->hex_color;
		_tmp6_ = self->priv->is_default_check;
		_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = self->priv->backend_widgets;
		maya_backend_add_new_calendar (_tmp1_, _tmp4_, _tmp5_, _tmp8_, _tmp9_);
		g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
	} else {
		MayaBackend* _tmp10_;
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		GtkCheckButton* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		GeeCollection* _tmp18_;
		ESource* _tmp19_;
		_tmp10_ = self->priv->current_backend;
		_tmp11_ = self->priv->name_entry;
		_tmp12_ = gtk_entry_get_text (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = self->priv->hex_color;
		_tmp15_ = self->priv->is_default_check;
		_tmp16_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = self->priv->backend_widgets;
		_tmp19_ = self->priv->source;
		maya_backend_modify_calendar (_tmp10_, _tmp13_, _tmp14_, _tmp17_, _tmp18_, _tmp19_);
		g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
	}
}

MayaViewSourceDialog*
maya_view_source_dialog_construct (GType object_type)
{
	MayaViewSourceDialog * self = NULL;
	self = (MayaViewSourceDialog*) g_object_new (object_type, NULL);
	return self;
}

MayaViewSourceDialog*
maya_view_source_dialog_new (void)
{
	return maya_view_source_dialog_construct (MAYA_VIEW_TYPE_SOURCE_DIALOG);
}

MayaViewEventType
maya_view_source_dialog_get_event_type (MayaViewSourceDialog* self)
{
	MayaViewEventType result;
	MayaViewEventType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_event_type;
	result = _tmp0_;
	return result;
}

static void
maya_view_source_dialog_set_event_type (MayaViewSourceDialog* self,
                                        MayaViewEventType value)
{
	g_return_if_fail (self != NULL);
	if (maya_view_source_dialog_get_event_type (self) != value) {
		self->priv->_event_type = value;
		g_object_notify_by_pspec ((GObject *) self, maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY]);
	}
}

static void
_maya_view_source_dialog_save_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	maya_view_source_dialog_save ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda157_ (MayaViewSourceDialog* self)
{
	g_signal_emit (self, maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL], 0);
}

static void
__maya_view_source_dialog___lambda157__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	_maya_view_source_dialog___lambda157_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda158_ (MayaViewSourceDialog* self)
{
	maya_view_source_dialog_check_can_validate (self);
}

static void
__maya_view_source_dialog___lambda158__gtk_editable_changed (GtkEditable* _sender,
                                                             gpointer self)
{
	_maya_view_source_dialog___lambda158_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda159_ (MayaViewSourceDialog* self)
{
	GValue backend = {0};
	GtkTreeIter b_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	MayaBackend* _tmp6_;
	GValue _tmp7_;
	ESource* _tmp8_;
	GeeCollection* _tmp9_;
	_tmp0_ = self->priv->type_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	b_iter = _tmp1_;
	_tmp2_ = self->priv->list_store;
	_tmp3_ = b_iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, 1, &_tmp4_);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
	backend = _tmp4_;
	_tmp5_ = backend;
	_tmp6_ = _g_object_ref0 (g_value_get_object (&_tmp5_));
	_g_object_unref0 (self->priv->current_backend);
	self->priv->current_backend = _tmp6_;
	maya_view_source_dialog_remove_backend_widgets (self);
	_tmp7_ = backend;
	_tmp8_ = self->priv->source;
	_tmp9_ = maya_backend_get_new_calendar_widget (g_value_get_object (&_tmp7_), _tmp8_);
	_g_object_unref0 (self->priv->backend_widgets);
	self->priv->backend_widgets = _tmp9_;
	maya_view_source_dialog_add_backend_widgets (self);
	G_IS_VALUE (&backend) ? (g_value_unset (&backend), NULL) : NULL;
}

static void
__maya_view_source_dialog___lambda159__gtk_combo_box_changed (GtkComboBox* _sender,
                                                              gpointer self)
{
	_maya_view_source_dialog___lambda159_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda160_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#da3d41");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda160__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda160_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda161_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#f37329");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda161__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda161_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda162_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#e6a92a");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda162__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda162_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda163_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#81c837");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda163__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda163_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda164_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#3689e6");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda164__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda164_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda165_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#a56de2");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda165__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda165_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda166_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#8a715e");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda166__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda166_ ((MayaViewSourceDialog*) self);
}

static void
_maya_view_source_dialog___lambda167_ (MayaViewSourceDialog* self)
{
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("#667885");
	_g_free0 (self->priv->hex_color);
	self->priv->hex_color = _tmp0_;
}

static void
__maya_view_source_dialog___lambda167__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_maya_view_source_dialog___lambda167_ ((MayaViewSourceDialog*) self);
}

static GObject *
maya_view_source_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MayaViewSourceDialog * self;
	GeeHashMap* _tmp0_;
	GtkButton* cancel_button = NULL;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButtonBox* buttonbox = NULL;
	GtkButtonBox* _tmp5_;
	GtkButtonBox* _tmp6_;
	GtkButtonBox* _tmp7_;
	GtkButtonBox* _tmp8_;
	GtkButton* _tmp9_;
	GtkButtonBox* _tmp10_;
	GtkButton* _tmp11_;
	GtkLabel* name_label = NULL;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkListStore* _tmp17_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp18_;
	GtkListStore* _tmp19_;
	GtkComboBox* _tmp20_;
	GtkComboBox* _tmp21_;
	GtkComboBox* _tmp22_;
	GtkCellRendererText* _tmp23_;
	GtkComboBox* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkLabel* type_label = NULL;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkTreeIter iter = {0};
	MayaBackendsManager* backends_manager = NULL;
	MayaBackendsManager* _tmp29_;
	MayaBackendsManager* _tmp49_;
	GeeArrayList* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	GtkComboBox* _tmp55_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp56_;
	GtkCssProvider* _tmp57_;
	GtkLabel* color_label = NULL;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkRadioButton* _tmp60_;
	GtkStyleContext* color_button_red_context = NULL;
	GtkRadioButton* _tmp61_;
	GtkStyleContext* _tmp62_;
	GtkStyleContext* _tmp63_;
	GtkStyleContext* _tmp64_;
	GtkStyleContext* _tmp65_;
	GtkStyleContext* _tmp66_;
	GtkCssProvider* _tmp67_;
	GtkRadioButton* _tmp68_;
	GtkRadioButton* _tmp69_;
	GtkStyleContext* color_button_orange_context = NULL;
	GtkRadioButton* _tmp70_;
	GtkStyleContext* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkStyleContext* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkStyleContext* _tmp75_;
	GtkCssProvider* _tmp76_;
	GtkRadioButton* _tmp77_;
	GtkRadioButton* _tmp78_;
	GtkStyleContext* color_button_yellow_context = NULL;
	GtkRadioButton* _tmp79_;
	GtkStyleContext* _tmp80_;
	GtkStyleContext* _tmp81_;
	GtkStyleContext* _tmp82_;
	GtkStyleContext* _tmp83_;
	GtkStyleContext* _tmp84_;
	GtkCssProvider* _tmp85_;
	GtkRadioButton* _tmp86_;
	GtkRadioButton* _tmp87_;
	GtkStyleContext* color_button_green_context = NULL;
	GtkRadioButton* _tmp88_;
	GtkStyleContext* _tmp89_;
	GtkStyleContext* _tmp90_;
	GtkStyleContext* _tmp91_;
	GtkStyleContext* _tmp92_;
	GtkStyleContext* _tmp93_;
	GtkCssProvider* _tmp94_;
	GtkRadioButton* _tmp95_;
	GtkRadioButton* _tmp96_;
	GtkStyleContext* color_button_blue_context = NULL;
	GtkRadioButton* _tmp97_;
	GtkStyleContext* _tmp98_;
	GtkStyleContext* _tmp99_;
	GtkStyleContext* _tmp100_;
	GtkStyleContext* _tmp101_;
	GtkStyleContext* _tmp102_;
	GtkCssProvider* _tmp103_;
	GtkRadioButton* _tmp104_;
	GtkRadioButton* _tmp105_;
	GtkStyleContext* color_button_purple_context = NULL;
	GtkRadioButton* _tmp106_;
	GtkStyleContext* _tmp107_;
	GtkStyleContext* _tmp108_;
	GtkStyleContext* _tmp109_;
	GtkStyleContext* _tmp110_;
	GtkStyleContext* _tmp111_;
	GtkCssProvider* _tmp112_;
	GtkRadioButton* _tmp113_;
	GtkRadioButton* _tmp114_;
	GtkStyleContext* color_button_brown_context = NULL;
	GtkRadioButton* _tmp115_;
	GtkStyleContext* _tmp116_;
	GtkStyleContext* _tmp117_;
	GtkStyleContext* _tmp118_;
	GtkStyleContext* _tmp119_;
	GtkStyleContext* _tmp120_;
	GtkCssProvider* _tmp121_;
	GtkRadioButton* _tmp122_;
	GtkRadioButton* _tmp123_;
	GtkStyleContext* color_button_slate_context = NULL;
	GtkRadioButton* _tmp124_;
	GtkStyleContext* _tmp125_;
	GtkStyleContext* _tmp126_;
	GtkStyleContext* _tmp127_;
	GtkStyleContext* _tmp128_;
	GtkStyleContext* _tmp129_;
	GtkCssProvider* _tmp130_;
	GtkRadioButton* _tmp131_;
	GtkRadioButton* _tmp132_;
	GtkGrid* color_grid = NULL;
	GtkGrid* _tmp133_;
	GtkGrid* _tmp134_;
	GtkGrid* _tmp135_;
	GtkRadioButton* _tmp136_;
	GtkGrid* _tmp137_;
	GtkRadioButton* _tmp138_;
	GtkGrid* _tmp139_;
	GtkRadioButton* _tmp140_;
	GtkGrid* _tmp141_;
	GtkRadioButton* _tmp142_;
	GtkGrid* _tmp143_;
	GtkRadioButton* _tmp144_;
	GtkGrid* _tmp145_;
	GtkRadioButton* _tmp146_;
	GtkGrid* _tmp147_;
	GtkRadioButton* _tmp148_;
	GtkGrid* _tmp149_;
	GtkRadioButton* _tmp150_;
	GtkCheckButton* _tmp151_;
	GtkRadioButton* _tmp152_;
	GtkRadioButton* _tmp153_;
	GtkRadioButton* _tmp154_;
	GtkRadioButton* _tmp155_;
	GtkRadioButton* _tmp156_;
	GtkRadioButton* _tmp157_;
	GtkRadioButton* _tmp158_;
	GtkRadioButton* _tmp159_;
	GtkGrid* _tmp160_;
	GtkGrid* _tmp161_;
	GtkGrid* _tmp162_;
	GtkGrid* _tmp163_;
	GtkLabel* _tmp164_;
	GtkGrid* _tmp165_;
	GtkComboBox* _tmp166_;
	GtkGrid* _tmp167_;
	GtkLabel* _tmp168_;
	GtkGrid* _tmp169_;
	GtkEntry* _tmp170_;
	GtkGrid* _tmp171_;
	GtkLabel* _tmp172_;
	GtkGrid* _tmp173_;
	GtkGrid* _tmp174_;
	GtkGrid* _tmp175_;
	GtkCheckButton* _tmp176_;
	GtkGrid* _tmp177_;
	GtkButtonBox* _tmp178_;
	parent_class = G_OBJECT_CLASS (maya_view_source_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->widgets_checked);
	self->priv->widgets_checked = _tmp0_;
	_tmp1_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
	g_object_ref_sink (_tmp1_);
	cancel_button = _tmp1_;
	_tmp2_ = (GtkButton*) gtk_button_new_with_label (_ ("Create"));
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->create_button);
	self->priv->create_button = _tmp2_;
	_tmp3_ = self->priv->create_button;
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) _maya_view_source_dialog_save_gtk_button_clicked, self, 0);
	_tmp4_ = cancel_button;
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) __maya_view_source_dialog___lambda157__gtk_button_clicked, self, 0);
	_tmp5_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp5_);
	buttonbox = _tmp5_;
	_tmp6_ = buttonbox;
	g_object_set (_tmp6_, "layout-style", GTK_BUTTONBOX_END, NULL);
	_tmp7_ = buttonbox;
	gtk_box_set_spacing ((GtkBox*) _tmp7_, 6);
	_tmp8_ = buttonbox;
	_tmp9_ = cancel_button;
	gtk_box_pack_end ((GtkBox*) _tmp8_, (GtkWidget*) _tmp9_, TRUE, TRUE, (guint) 0);
	_tmp10_ = buttonbox;
	_tmp11_ = self->priv->create_button;
	gtk_box_pack_end ((GtkBox*) _tmp10_, (GtkWidget*) _tmp11_, TRUE, TRUE, (guint) 0);
	_tmp12_ = (GtkLabel*) gtk_label_new (_ ("Name:"));
	g_object_ref_sink (_tmp12_);
	name_label = _tmp12_;
	_tmp13_ = name_label;
	gtk_label_set_xalign (_tmp13_, (gfloat) 1);
	_tmp14_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->name_entry);
	self->priv->name_entry = _tmp14_;
	_tmp15_ = self->priv->name_entry;
	gtk_entry_set_placeholder_text (_tmp15_, _ ("Calendar Name"));
	_tmp16_ = self->priv->name_entry;
	g_signal_connect_object ((GtkEditable*) _tmp16_, "changed", (GCallback) __maya_view_source_dialog___lambda158__gtk_editable_changed, self, 0);
	_tmp17_ = gtk_list_store_new (2, G_TYPE_STRING, MAYA_TYPE_BACKEND, -1);
	_g_object_unref0 (self->priv->list_store);
	self->priv->list_store = _tmp17_;
	_tmp18_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp18_);
	renderer = _tmp18_;
	_tmp19_ = self->priv->list_store;
	_tmp20_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp19_);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->type_combobox);
	self->priv->type_combobox = _tmp20_;
	_tmp21_ = self->priv->type_combobox;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
	_tmp22_ = self->priv->type_combobox;
	_tmp23_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp22_, (GtkCellRenderer*) _tmp23_, TRUE);
	_tmp24_ = self->priv->type_combobox;
	_tmp25_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp24_, (GtkCellRenderer*) _tmp25_, "text", 0);
	_tmp26_ = self->priv->type_combobox;
	g_signal_connect_object (_tmp26_, "changed", (GCallback) __maya_view_source_dialog___lambda159__gtk_combo_box_changed, self, 0);
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Type:"));
	g_object_ref_sink (_tmp27_);
	type_label = _tmp27_;
	_tmp28_ = type_label;
	gtk_label_set_xalign (_tmp28_, 1.0f);
	_tmp29_ = maya_backends_manager_get_default ();
	backends_manager = _tmp29_;
	{
		GeeArrayList* _backend_list = NULL;
		MayaBackendsManager* _tmp30_;
		GeeArrayList* _tmp31_;
		GeeArrayList* _tmp32_;
		gint _backend_size = 0;
		GeeArrayList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gint _backend_index = 0;
		_tmp30_ = backends_manager;
		_tmp31_ = _tmp30_->backends;
		_tmp32_ = _g_object_ref0 (_tmp31_);
		_backend_list = _tmp32_;
		_tmp33_ = _backend_list;
		_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
		_tmp35_ = _tmp34_;
		_backend_size = _tmp35_;
		_backend_index = -1;
		while (TRUE) {
			gint _tmp36_;
			gint _tmp37_;
			MayaBackend* backend = NULL;
			GeeArrayList* _tmp38_;
			gpointer _tmp39_;
			MayaBackend* _tmp40_;
			GtkListStore* _tmp41_;
			GtkTreeIter _tmp42_ = {0};
			GtkListStore* _tmp43_;
			GtkTreeIter _tmp44_;
			MayaBackend* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			MayaBackend* _tmp48_;
			_backend_index = _backend_index + 1;
			_tmp36_ = _backend_index;
			_tmp37_ = _backend_size;
			if (!(_tmp36_ < _tmp37_)) {
				break;
			}
			_tmp38_ = _backend_list;
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp38_, _backend_index);
			_tmp40_ = _g_object_ref0 ((MayaBackend*) _tmp39_);
			backend = _tmp40_;
			_tmp41_ = self->priv->list_store;
			gtk_list_store_append (_tmp41_, &_tmp42_);
			iter = _tmp42_;
			_tmp43_ = self->priv->list_store;
			_tmp44_ = iter;
			_tmp45_ = backend;
			_tmp46_ = maya_backend_get_name (_tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = backend;
			gtk_list_store_set (_tmp43_, &_tmp44_, 0, _tmp47_, 1, _tmp48_, -1);
			_g_free0 (_tmp47_);
			_g_object_unref0 (backend);
		}
		_g_object_unref0 (_backend_list);
	}
	_tmp49_ = backends_manager;
	_tmp50_ = _tmp49_->backends;
	_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
	_tmp52_ = _tmp51_;
	if (_tmp52_ <= 1) {
		GtkComboBox* _tmp53_;
		GtkLabel* _tmp54_;
		_tmp53_ = self->priv->type_combobox;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp53_, TRUE);
		_tmp54_ = type_label;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp54_, TRUE);
	}
	_tmp55_ = self->priv->type_combobox;
	gtk_combo_box_set_active (_tmp55_, 0);
	_tmp56_ = gtk_css_provider_new ();
	css_provider = _tmp56_;
	_tmp57_ = css_provider;
	gtk_css_provider_load_from_resource (_tmp57_, "/io/elementary/calendar/ColorButton.css");
	_tmp58_ = (GtkLabel*) gtk_label_new (_ ("Color:"));
	g_object_ref_sink (_tmp58_);
	color_label = _tmp58_;
	_tmp59_ = color_label;
	gtk_label_set_xalign (_tmp59_, (gfloat) 1);
	_tmp60_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp60_);
	_g_object_unref0 (self->priv->color_button_red);
	self->priv->color_button_red = _tmp60_;
	_tmp61_ = self->priv->color_button_red;
	_tmp62_ = gtk_widget_get_style_context ((GtkWidget*) _tmp61_);
	_tmp63_ = _g_object_ref0 (_tmp62_);
	color_button_red_context = _tmp63_;
	_tmp64_ = color_button_red_context;
	gtk_style_context_add_class (_tmp64_, "color-button");
	_tmp65_ = color_button_red_context;
	gtk_style_context_add_class (_tmp65_, "red");
	_tmp66_ = color_button_red_context;
	_tmp67_ = css_provider;
	gtk_style_context_add_provider (_tmp66_, (GtkStyleProvider*) _tmp67_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp68_ = self->priv->color_button_red;
	_tmp69_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp68_);
	g_object_ref_sink (_tmp69_);
	_g_object_unref0 (self->priv->color_button_orange);
	self->priv->color_button_orange = _tmp69_;
	_tmp70_ = self->priv->color_button_orange;
	_tmp71_ = gtk_widget_get_style_context ((GtkWidget*) _tmp70_);
	_tmp72_ = _g_object_ref0 (_tmp71_);
	color_button_orange_context = _tmp72_;
	_tmp73_ = color_button_orange_context;
	gtk_style_context_add_class (_tmp73_, "color-button");
	_tmp74_ = color_button_orange_context;
	gtk_style_context_add_class (_tmp74_, "orange");
	_tmp75_ = color_button_orange_context;
	_tmp76_ = css_provider;
	gtk_style_context_add_provider (_tmp75_, (GtkStyleProvider*) _tmp76_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp77_ = self->priv->color_button_red;
	_tmp78_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp77_);
	g_object_ref_sink (_tmp78_);
	_g_object_unref0 (self->priv->color_button_yellow);
	self->priv->color_button_yellow = _tmp78_;
	_tmp79_ = self->priv->color_button_yellow;
	_tmp80_ = gtk_widget_get_style_context ((GtkWidget*) _tmp79_);
	_tmp81_ = _g_object_ref0 (_tmp80_);
	color_button_yellow_context = _tmp81_;
	_tmp82_ = color_button_yellow_context;
	gtk_style_context_add_class (_tmp82_, "color-button");
	_tmp83_ = color_button_yellow_context;
	gtk_style_context_add_class (_tmp83_, "yellow");
	_tmp84_ = color_button_yellow_context;
	_tmp85_ = css_provider;
	gtk_style_context_add_provider (_tmp84_, (GtkStyleProvider*) _tmp85_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp86_ = self->priv->color_button_red;
	_tmp87_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp86_);
	g_object_ref_sink (_tmp87_);
	_g_object_unref0 (self->priv->color_button_green);
	self->priv->color_button_green = _tmp87_;
	_tmp88_ = self->priv->color_button_green;
	_tmp89_ = gtk_widget_get_style_context ((GtkWidget*) _tmp88_);
	_tmp90_ = _g_object_ref0 (_tmp89_);
	color_button_green_context = _tmp90_;
	_tmp91_ = color_button_green_context;
	gtk_style_context_add_class (_tmp91_, "color-button");
	_tmp92_ = color_button_green_context;
	gtk_style_context_add_class (_tmp92_, "green");
	_tmp93_ = color_button_green_context;
	_tmp94_ = css_provider;
	gtk_style_context_add_provider (_tmp93_, (GtkStyleProvider*) _tmp94_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp95_ = self->priv->color_button_red;
	_tmp96_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp95_);
	g_object_ref_sink (_tmp96_);
	_g_object_unref0 (self->priv->color_button_blue);
	self->priv->color_button_blue = _tmp96_;
	_tmp97_ = self->priv->color_button_blue;
	_tmp98_ = gtk_widget_get_style_context ((GtkWidget*) _tmp97_);
	_tmp99_ = _g_object_ref0 (_tmp98_);
	color_button_blue_context = _tmp99_;
	_tmp100_ = color_button_blue_context;
	gtk_style_context_add_class (_tmp100_, "color-button");
	_tmp101_ = color_button_blue_context;
	gtk_style_context_add_class (_tmp101_, "blue");
	_tmp102_ = color_button_blue_context;
	_tmp103_ = css_provider;
	gtk_style_context_add_provider (_tmp102_, (GtkStyleProvider*) _tmp103_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp104_ = self->priv->color_button_red;
	_tmp105_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp104_);
	g_object_ref_sink (_tmp105_);
	_g_object_unref0 (self->priv->color_button_purple);
	self->priv->color_button_purple = _tmp105_;
	_tmp106_ = self->priv->color_button_purple;
	_tmp107_ = gtk_widget_get_style_context ((GtkWidget*) _tmp106_);
	_tmp108_ = _g_object_ref0 (_tmp107_);
	color_button_purple_context = _tmp108_;
	_tmp109_ = color_button_purple_context;
	gtk_style_context_add_class (_tmp109_, "color-button");
	_tmp110_ = color_button_purple_context;
	gtk_style_context_add_class (_tmp110_, "purple");
	_tmp111_ = color_button_purple_context;
	_tmp112_ = css_provider;
	gtk_style_context_add_provider (_tmp111_, (GtkStyleProvider*) _tmp112_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp113_ = self->priv->color_button_red;
	_tmp114_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp113_);
	g_object_ref_sink (_tmp114_);
	_g_object_unref0 (self->priv->color_button_brown);
	self->priv->color_button_brown = _tmp114_;
	_tmp115_ = self->priv->color_button_brown;
	_tmp116_ = gtk_widget_get_style_context ((GtkWidget*) _tmp115_);
	_tmp117_ = _g_object_ref0 (_tmp116_);
	color_button_brown_context = _tmp117_;
	_tmp118_ = color_button_brown_context;
	gtk_style_context_add_class (_tmp118_, "color-button");
	_tmp119_ = color_button_brown_context;
	gtk_style_context_add_class (_tmp119_, "brown");
	_tmp120_ = color_button_brown_context;
	_tmp121_ = css_provider;
	gtk_style_context_add_provider (_tmp120_, (GtkStyleProvider*) _tmp121_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp122_ = self->priv->color_button_red;
	_tmp123_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp122_);
	g_object_ref_sink (_tmp123_);
	_g_object_unref0 (self->priv->color_button_slate);
	self->priv->color_button_slate = _tmp123_;
	_tmp124_ = self->priv->color_button_slate;
	_tmp125_ = gtk_widget_get_style_context ((GtkWidget*) _tmp124_);
	_tmp126_ = _g_object_ref0 (_tmp125_);
	color_button_slate_context = _tmp126_;
	_tmp127_ = color_button_slate_context;
	gtk_style_context_add_class (_tmp127_, "color-button");
	_tmp128_ = color_button_slate_context;
	gtk_style_context_add_class (_tmp128_, "slate");
	_tmp129_ = color_button_slate_context;
	_tmp130_ = css_provider;
	gtk_style_context_add_provider (_tmp129_, (GtkStyleProvider*) _tmp130_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp131_ = self->priv->color_button_red;
	_tmp132_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp131_);
	g_object_ref_sink (_tmp132_);
	_g_object_unref0 (self->priv->color_button_none);
	self->priv->color_button_none = _tmp132_;
	_tmp133_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp133_);
	color_grid = _tmp133_;
	_tmp134_ = color_grid;
	gtk_grid_set_column_spacing (_tmp134_, 12);
	_tmp135_ = color_grid;
	_tmp136_ = self->priv->color_button_red;
	gtk_container_add ((GtkContainer*) _tmp135_, (GtkWidget*) _tmp136_);
	_tmp137_ = color_grid;
	_tmp138_ = self->priv->color_button_orange;
	gtk_container_add ((GtkContainer*) _tmp137_, (GtkWidget*) _tmp138_);
	_tmp139_ = color_grid;
	_tmp140_ = self->priv->color_button_yellow;
	gtk_container_add ((GtkContainer*) _tmp139_, (GtkWidget*) _tmp140_);
	_tmp141_ = color_grid;
	_tmp142_ = self->priv->color_button_green;
	gtk_container_add ((GtkContainer*) _tmp141_, (GtkWidget*) _tmp142_);
	_tmp143_ = color_grid;
	_tmp144_ = self->priv->color_button_blue;
	gtk_container_add ((GtkContainer*) _tmp143_, (GtkWidget*) _tmp144_);
	_tmp145_ = color_grid;
	_tmp146_ = self->priv->color_button_purple;
	gtk_container_add ((GtkContainer*) _tmp145_, (GtkWidget*) _tmp146_);
	_tmp147_ = color_grid;
	_tmp148_ = self->priv->color_button_brown;
	gtk_container_add ((GtkContainer*) _tmp147_, (GtkWidget*) _tmp148_);
	_tmp149_ = color_grid;
	_tmp150_ = self->priv->color_button_slate;
	gtk_container_add ((GtkContainer*) _tmp149_, (GtkWidget*) _tmp150_);
	_tmp151_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Mark as default calendar"));
	g_object_ref_sink (_tmp151_);
	_g_object_unref0 (self->priv->is_default_check);
	self->priv->is_default_check = _tmp151_;
	_tmp152_ = self->priv->color_button_red;
	g_signal_connect_object ((GtkToggleButton*) _tmp152_, "toggled", (GCallback) __maya_view_source_dialog___lambda160__gtk_toggle_button_toggled, self, 0);
	_tmp153_ = self->priv->color_button_orange;
	g_signal_connect_object ((GtkToggleButton*) _tmp153_, "toggled", (GCallback) __maya_view_source_dialog___lambda161__gtk_toggle_button_toggled, self, 0);
	_tmp154_ = self->priv->color_button_yellow;
	g_signal_connect_object ((GtkToggleButton*) _tmp154_, "toggled", (GCallback) __maya_view_source_dialog___lambda162__gtk_toggle_button_toggled, self, 0);
	_tmp155_ = self->priv->color_button_green;
	g_signal_connect_object ((GtkToggleButton*) _tmp155_, "toggled", (GCallback) __maya_view_source_dialog___lambda163__gtk_toggle_button_toggled, self, 0);
	_tmp156_ = self->priv->color_button_blue;
	g_signal_connect_object ((GtkToggleButton*) _tmp156_, "toggled", (GCallback) __maya_view_source_dialog___lambda164__gtk_toggle_button_toggled, self, 0);
	_tmp157_ = self->priv->color_button_purple;
	g_signal_connect_object ((GtkToggleButton*) _tmp157_, "toggled", (GCallback) __maya_view_source_dialog___lambda165__gtk_toggle_button_toggled, self, 0);
	_tmp158_ = self->priv->color_button_brown;
	g_signal_connect_object ((GtkToggleButton*) _tmp158_, "toggled", (GCallback) __maya_view_source_dialog___lambda166__gtk_toggle_button_toggled, self, 0);
	_tmp159_ = self->priv->color_button_slate;
	g_signal_connect_object ((GtkToggleButton*) _tmp159_, "toggled", (GCallback) __maya_view_source_dialog___lambda167__gtk_toggle_button_toggled, self, 0);
	_tmp160_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp160_);
	_g_object_unref0 (self->priv->main_grid);
	self->priv->main_grid = _tmp160_;
	_tmp161_ = self->priv->main_grid;
	gtk_grid_set_row_spacing (_tmp161_, 6);
	_tmp162_ = self->priv->main_grid;
	gtk_grid_set_column_spacing (_tmp162_, 12);
	_tmp163_ = self->priv->main_grid;
	_tmp164_ = type_label;
	gtk_grid_attach (_tmp163_, (GtkWidget*) _tmp164_, 0, 0, 1, 1);
	_tmp165_ = self->priv->main_grid;
	_tmp166_ = self->priv->type_combobox;
	gtk_grid_attach (_tmp165_, (GtkWidget*) _tmp166_, 1, 0, 1, 1);
	_tmp167_ = self->priv->main_grid;
	_tmp168_ = name_label;
	gtk_grid_attach (_tmp167_, (GtkWidget*) _tmp168_, 0, 1, 1, 1);
	_tmp169_ = self->priv->main_grid;
	_tmp170_ = self->priv->name_entry;
	gtk_grid_attach (_tmp169_, (GtkWidget*) _tmp170_, 1, 1, 1, 1);
	_tmp171_ = self->priv->main_grid;
	_tmp172_ = color_label;
	gtk_grid_attach (_tmp171_, (GtkWidget*) _tmp172_, 0, 2, 1, 1);
	_tmp173_ = self->priv->main_grid;
	_tmp174_ = color_grid;
	gtk_grid_attach (_tmp173_, (GtkWidget*) _tmp174_, 1, 2, 1, 1);
	_tmp175_ = self->priv->main_grid;
	_tmp176_ = self->priv->is_default_check;
	gtk_grid_attach (_tmp175_, (GtkWidget*) _tmp176_, 1, 3, 1, 1);
	g_object_set ((GtkWidget*) self, "margin", 12, NULL);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 8);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 24);
	_tmp177_ = self->priv->main_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp177_, 0, 0, 1, 1);
	_tmp178_ = buttonbox;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp178_, 0, 1, 1, 1);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (color_grid);
	_g_object_unref0 (color_button_slate_context);
	_g_object_unref0 (color_button_brown_context);
	_g_object_unref0 (color_button_purple_context);
	_g_object_unref0 (color_button_blue_context);
	_g_object_unref0 (color_button_green_context);
	_g_object_unref0 (color_button_yellow_context);
	_g_object_unref0 (color_button_orange_context);
	_g_object_unref0 (color_button_red_context);
	_g_object_unref0 (color_label);
	_g_object_unref0 (css_provider);
	_g_object_unref0 (backends_manager);
	_g_object_unref0 (type_label);
	_g_object_unref0 (renderer);
	_g_object_unref0 (name_label);
	_g_object_unref0 (buttonbox);
	_g_object_unref0 (cancel_button);
	return obj;
}

static void
maya_view_source_dialog_class_init (MayaViewSourceDialogClass * klass,
                                    gpointer klass_data)
{
	maya_view_source_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MayaViewSourceDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_maya_view_source_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_maya_view_source_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = maya_view_source_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = maya_view_source_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY, maya_view_source_dialog_properties[MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY] = g_param_spec_enum ("event-type", "event-type", "event-type", MAYA_VIEW_TYPE_EVENT_TYPE, MAYA_VIEW_EVENT_TYPE_EDIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	maya_view_source_dialog_signals[MAYA_VIEW_SOURCE_DIALOG_GO_BACK_SIGNAL] = g_signal_new ("go-back", MAYA_VIEW_TYPE_SOURCE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
maya_view_source_dialog_instance_init (MayaViewSourceDialog * self,
                                       gpointer klass)
{
	gchar* _tmp0_;
	self->priv = maya_view_source_dialog_get_instance_private (self);
	self->priv->_event_type = MAYA_VIEW_EVENT_TYPE_EDIT;
	_tmp0_ = g_strdup ("#da3d41");
	self->priv->hex_color = _tmp0_;
	self->priv->source = NULL;
}

static void
maya_view_source_dialog_finalize (GObject * obj)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	_g_object_unref0 (self->priv->name_entry);
	_g_free0 (self->priv->hex_color);
	_g_object_unref0 (self->priv->current_backend);
	_g_object_unref0 (self->priv->backend_widgets);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->widgets_checked);
	_g_object_unref0 (self->priv->create_button);
	_g_object_unref0 (self->priv->type_combobox);
	_g_object_unref0 (self->priv->list_store);
	_g_object_unref0 (self->priv->is_default_check);
	_g_object_unref0 (self->priv->source);
	_g_object_unref0 (self->priv->color_button_red);
	_g_object_unref0 (self->priv->color_button_orange);
	_g_object_unref0 (self->priv->color_button_yellow);
	_g_object_unref0 (self->priv->color_button_green);
	_g_object_unref0 (self->priv->color_button_blue);
	_g_object_unref0 (self->priv->color_button_purple);
	_g_object_unref0 (self->priv->color_button_brown);
	_g_object_unref0 (self->priv->color_button_slate);
	_g_object_unref0 (self->priv->color_button_none);
	G_OBJECT_CLASS (maya_view_source_dialog_parent_class)->finalize (obj);
}

static GType
maya_view_source_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaViewSourceDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_view_source_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaViewSourceDialog), 0, (GInstanceInitFunc) maya_view_source_dialog_instance_init, NULL };
	GType maya_view_source_dialog_type_id;
	maya_view_source_dialog_type_id = g_type_register_static (gtk_grid_get_type (), "MayaViewSourceDialog", &g_define_type_info, 0);
	MayaViewSourceDialog_private_offset = g_type_add_instance_private (maya_view_source_dialog_type_id, sizeof (MayaViewSourceDialogPrivate));
	return maya_view_source_dialog_type_id;
}

GType
maya_view_source_dialog_get_type (void)
{
	static volatile gsize maya_view_source_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&maya_view_source_dialog_type_id__volatile)) {
		GType maya_view_source_dialog_type_id;
		maya_view_source_dialog_type_id = maya_view_source_dialog_get_type_once ();
		g_once_init_leave (&maya_view_source_dialog_type_id__volatile, maya_view_source_dialog_type_id);
	}
	return maya_view_source_dialog_type_id__volatile;
}

static void
_vala_maya_view_source_dialog_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	switch (property_id) {
		case MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY:
		g_value_set_enum (value, maya_view_source_dialog_get_event_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_maya_view_source_dialog_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	MayaViewSourceDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MAYA_VIEW_TYPE_SOURCE_DIALOG, MayaViewSourceDialog);
	switch (property_id) {
		case MAYA_VIEW_SOURCE_DIALOG_EVENT_TYPE_PROPERTY:
		maya_view_source_dialog_set_event_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

